#include "header.h"
#include "uart.h"


//***************************************************
//Funktion fr das Empfangen des Acknowledge Byte Master
//***************************************************
void master_receive_acknowledge(void){	
	
	if(Rx.Receive_Byte_Counter == 0){		
		Rx.HI_Checksumme=RF12_receive_WRT_CMD(0xB000);	// Checksumme auslesen
		Rx.Receive_Byte_Counter++;
		return;
	}

	if(Rx.Receive_Byte_Counter == 1){
	
		Rx.LOW_Checksumme=RF12_receive_WRT_CMD(0xB000);	// Checksumme auslesen
	
		RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1	
		RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode	
		RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
		
		Rx.Receive_Byte_Counter = 0;	// Paket Byte Counter wieder auf 0 setzen
		Tx.Transmit_Byte_Counter = 0;	// Paket Byte Counter wieder auf 0 setzen
		
		//BYTES ZUSAMMENFHREN
		Rx.i_Checksumme = Rx.HI_Checksumme<<8 | Rx.LOW_Checksumme;		
		
		//WENN CHECKSUMME STIMMT
		if(Rx.i_Checksumme == Tx.i_Checksumme_Calc){
			//ZURCK IN DEN NORMALEN MODUS
			Set_Modus_MasterReceiveData();					// Modus setzen 
			Tx.Resend_Flag = 0;								// Im nchsten Zyklus kein Resend ntig(Wurde beim Senden auf 1 gesetzt)				
			Ringpuffer_UART_to_RFM.WriteReadDifference--;	// Differenz lesen Schreiben verringern
			Tx.Correct_Transmit_Counter++;					// Counter fr korrekte bertragung erhhen	
		
		}
		//WENN CHECKSUMME NICHT STIMMT
		else{
			//DATEN BEIM NCHSTEN ZYKLUS ERNEUT SENDEN
			Set_Modus_MasterResendData();					// --> Tx.Resend_Flag = 1 --> erneutes Senden im nchsten Zylus
		}

		Rx.Receive_Wait_Ack_Counter = 0;					// Paket Counter zurcksetzen
		return;
	}
	else{
		Rx.Receive_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
	}
}
//***************************************************
//***************************************************


//***************************************************
//Funktion fr das Empfangen eines Request
//***************************************************
void master_receive_request(void){		
	
	if(Rx.Receive_Byte_Counter == 0){
		Rx.i_Checksumme_Calc = 0;
	}

	if(Rx.Receive_Byte_Counter == 0){											// DatenBytes auslesen
		Identifier.ID_Transmited_High=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen
		Rx.Receive_Byte_Counter++;
		return;
	}
	
	if(Rx.Receive_Byte_Counter == 1){											// DatenBytes auslesen
		Identifier.ID_Transmited_Low=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen
		//ID_Control();
		Rx.Receive_Byte_Counter++;
		return;			
	}		
	
	if(Rx.Receive_Byte_Counter == 2){											// DatenBytes auslesen
		Rx.Master_Receive_Messege_Type=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen	
		Rx.Receive_Byte_Counter++;
		return;		
	}
	
	// WENN 3. BYTE 0xAA --> SLAVE SENDET DATEN!!!
	// MASTER ERTWARTET 16  DATENBYTES
	if (Rx.Master_Receive_Messege_Type == 0xAA){										// Daten werden gesendet

		if((Rx.Receive_Byte_Counter > 2) & (Rx.Receive_Byte_Counter < 19)){				// DatenBytes auslesen
			Rx.FiFo_Puffer [Rx.Receive_Byte_Counter-3]=RF12_receive_WRT_CMD(0xB000);  	// B0xx: FIFO Daten auslesen
			Rx.i_Checksumme_Calc += Rx.FiFo_Puffer [Rx.Receive_Byte_Counter-3];			// Berechnung der Checksumme
			Rx.Receive_Byte_Counter++;
			return;
		}	
		
		// CHECKSUMME AUSLESEN
		if(Rx.Receive_Byte_Counter == 19){
			//nach letztem Byte erneut Synchronisieren
			Rx.HI_Checksumme=RF12_receive_WRT_CMD(0xB000);	// Checksumme auslesen
			Rx.Receive_Byte_Counter++;
			return;
		}
		// CHECKSUMME AUSLESEN
		if(Rx.Receive_Byte_Counter == 20){
			Rx.LOW_Checksumme=RF12_receive_WRT_CMD(0xB000);	// Checksumme auslesen

			//ZURCK IN DEN RECEIVEMODUS
			RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=0, ex=1, eb=0, ew=0, dc=1
			RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
			RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
			
			Statusregister = RF12_receive_WRT_CMD(0x0000);

			// DATEN IM PUFFER			
			Rx.Flag = 1;												// Flag setzten
			Rx.Receive_Byte_Counter = 0;								// Paket Byte Counter wieder auf 0 setzen
			Rx.Master_Receive_Messege_Type = 0;							// MSG Type wieder auf 0
			Rx.i_Checksumme = Rx.HI_Checksumme<<8 | Rx.LOW_Checksumme;	// Checksumme zusammenfhren
			return;

		}
		else{
			Rx.Receive_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
		}
	}

	// WENN 3. BYTE 0x9A --> SLAVE SENDET KEINE DATEN!!!
	// MASTER ERTWARTET WIEDER ID! 
	if (Rx.Master_Receive_Messege_Type == 0x9A){
		
		if(Rx.Receive_Byte_Counter == 3){											// DatenBytes auslesen
			Identifier.ID_Transmited_High=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen
			Rx.Receive_Byte_Counter++;
			return;		
		}
		
		if(Rx.Receive_Byte_Counter == 4){

			Identifier.ID_Transmited_Low=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen

			//ZURCK IN DEN RECEIVEMODUS
			RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
			RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
			RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
			
			Statusregister = RF12_receive_WRT_CMD(0x0000);
			//itoa(Statusregister,text,10);
			//uart_puts("\r\n Statusregister:");
			//uart_puts(text);
		
			Rx.Receive_Byte_Counter = 0;		// Paket Byte Counter wieder auf 0 setzen
			Rx.Master_Receive_Messege_Type = 0;	// MSG Type wieder auf 0
			//ZURCK IN DEN RECEIVEMODUS
			Set_Modus_MasterReceiveData();		//
			return;
			
		}
		else{
			Rx.Receive_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
		}
	}

	if (Rx.Master_Receive_Messege_Type == 0){
		Rx.Receive_Byte_Counter++;
	}

	TOGGLE_LED1();
}


//***************************************************
//***************************************************
