#include "header.h"
#include "uart.h"


//***************************************************
//Funktion fr das Lesen von einem Paket
//***************************************************
void Read_a_Packet_RFM(void){

// ID VORGABE IN funktionen.c (Main_Init();) 	

	//WENN SLAVE
	if(Identifier.ID_My_Board == Identifier.ID_Board_2){	// Check ob BoardID == SlaveID
		
		// DATEN EMPFANGEN ?
		if (Rx.Flag == 1){									// Daten empfangen?
			if (Rx.i_Checksumme_Calc == Rx.i_Checksumme){	// Checksummevergleich						
				Send_Acknowledge();							// Acknowledge Senden
				for(int i=0;i<16;i++){						// Daten in den Ringpuffer schreiben
					WriteAByte(Rx.FiFo_Puffer[i],2);				
					}											
				Rx.Correct_Receive_Counter++;				// Daten korrekt empfangen erhhen
				Rx.All_Receive_Paket_Counter++;					
				Rx.Flag = 0;								// Flag zurcksetzten, Daten gelesen
				
			}
			// ANDERNFALLS, KEIN ACKNOWLEDGE SENDEN!!!
			// --> MASTER SENDET IM NCHSTEN ZYKLUS DATEN NOCHMAL
			else{		
				Rx.Incorrect_Receive_Counter++;				// Daten NICHT korrekt empfangen erhhen
				//error_handler(ChecksummeError);			// in den Fehlerspeicher schreiben*/
				Rx.Flag = 0;								// Flag zurcksetzten
				}
			}
		
		// REQUEST ERHLATEN?
		if (Rx.RequestFlag == 1){				
			// PAKET IM RINGPUFFER VORHANDEN?
			// --> DATEN SENDEN
			if (Ringpuffer_UART_to_RFM.WriteReadDifference>0){
				Set_Modus_SlaveTransmitData();					// Modus setzen
			}
			//ANDERNFALLS KEINE DATEN SENDEN
			else{
				delay_ms(4);
				Set_Modus_SlaveTransmitRequest();				// Modus setzen
			}
			Slave_Send_a_Packet(Identifier.ID_Board_1);			// in Funktion_Senden_Slave.c 
			Rx.RequestFlag = 0;									// Flag zurcksetzten
		}
	}
	
	//WENN MASTER
	if(Identifier.ID_My_Board == Identifier.ID_Board_1){			//Check ob BoardID == MasterID				
				// DATEN EMPFANGEN ?
		if (Rx.Flag == 1){													
			
			if (Rx.i_Checksumme_Calc == Rx.i_Checksumme){	// Checksummevergleich
				Master_Send_Acknowledge();					// Acknowledge Senden
				for(int i=0;i<16;i++){						// Daten in den Ringpuffer schreiben
					WriteAByte(Rx.FiFo_Puffer[i],2);			
				}																						
				Rx.Correct_Receive_Counter++;				// Daten korrekt empfangen erhhen
				Rx.All_Receive_Paket_Counter++;
				Rx.Flag = 0;								// Flag zurcksetzten
			}
			
			// ANDERNFALLS, KEIN ACKNOWLEDGE SENDEN!!!
			// --> SLAVE SENDET NACH DEM NCHSTEN REQUEST DATEN NOCHMAL
			else{											
				Rx.Incorrect_Receive_Counter++;				// Daten NICHT korrekt empfangen erhhen
				Rx.Flag = 0;								// Flag zurcksetzten ... keine Daten im Array FiFo Puffer	
			}
		}
	}
}

//***************************************************
//***************************************************


//***************************************************
//Funktion fr das Empfangen vom Slave
//***************************************************
void slave_receive_bytes(void){		
	
	if(Rx.Receive_Byte_Counter == 0){											// beim ersten Byte Checksumme zurcksetzen
		//teststatus = RF12_receive_WRT_CMD(0x0000);
		Rx.i_Checksumme_Calc = 0;				
	}	
	
	if(Rx.Receive_Byte_Counter == 0){											// DatenBytes auslesen
		Identifier.ID_Transmited_High=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen
		Rx.Receive_Byte_Counter++;
		return;
	}
	
	if(Rx.Receive_Byte_Counter == 1){											// DatenBytes auslesen
		Identifier.ID_Transmited_Low=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen
		//ID_Control();		
		Rx.Receive_Byte_Counter++;
		return;	
	}		

	if(Rx.Receive_Byte_Counter == 2){											// DatenBytes auslesen
		Rx.Slave_Receive_Messege_Type=RF12_receive_WRT_CMD(0xB000);  			// B0xx: FIFO Daten auslesen		
		Rx.Receive_Byte_Counter++;
		return;
	}
	
	// WENN 3. BYTE 0xAA --> MASTER SENDET DATEN!!!
	// SLAVE ERTWARTET 16 DATENBYTES
	if (Rx.Slave_Receive_Messege_Type == 0xAA){									
		
		if((Rx.Receive_Byte_Counter > 2) & (Rx.Receive_Byte_Counter < 19)){											// DatenBytes auslesen
			Rx.FiFo_Puffer [Rx.Receive_Byte_Counter-3]=RF12_receive_WRT_CMD(0xB000);  // B0xx: FIFO Daten auslesen
			Rx.i_Checksumme_Calc += Rx.FiFo_Puffer [Rx.Receive_Byte_Counter-3];			// Berechnung der Checksumme 
			Rx.Receive_Byte_Counter++;
			return;
		}	

		if(Rx.Receive_Byte_Counter == 19){
			//nach letztem Byte erneut Synchronisieren
			Rx.HI_Checksumme=RF12_receive_WRT_CMD(0xB000);	// Checksumme auslesen
			Rx.Receive_Byte_Counter++;
			return;
		}
	
		if(Rx.Receive_Byte_Counter == 20){
			//nach letztem Byte erneut Synchronisieren
			Rx.LOW_Checksumme=RF12_receive_WRT_CMD(0xB000);	// Checksumme auslesen			

			RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
			RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
			RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
			
			Statusregister = RF12_receive_WRT_CMD(0x0000);

			Rx.Flag = 1;												// Flag setzten, Daten vorhanden
			Rx.Receive_Byte_Counter = 0;								// Paket Byte Counter wieder auf 0 setzen
			Rx.Slave_Receive_Messege_Type	= 0;						// MSG Type wieder auf 0
			Rx.i_Checksumme = Rx.HI_Checksumme<<8 | Rx.LOW_Checksumme;	// Checksumme zusammenfhren
			return;

		}else{
			Rx.Receive_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
		}
	}

	// WENN 3. BYTE 0x9A --> MASTER SENDET REQUESTANFRAGE!!!
	// SLAVE ERTWARTET WIEDER ID! 
	if (Rx.Slave_Receive_Messege_Type == 0x9A){								// Request Anfrage
		
		if(Rx.Receive_Byte_Counter == 3){									// DatenBytes auslesen
			Identifier.ID_Transmited_High=RF12_receive_WRT_CMD(0xB000);  	// B0xx: FIFO Daten auslesen
		}
		
		if(Rx.Receive_Byte_Counter == 4){
			Identifier.ID_Transmited_Low=RF12_receive_WRT_CMD(0xB000);  	// B0xx: FIFO Daten auslesen
			
			RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
			RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
			RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
			
			Statusregister = RF12_receive_WRT_CMD(0x0000);
			
	//		Statusregister = RF12_receive_WRT_CMD(0x0000);
	//		itoa(teststatus,text,10);
	//		uart_puts("\r\n teststatus:");
	//		uart_puts(text);
						
			Rx.RequestFlag = 1;					// Flag setzen, Requestanfrage erhalten		
			Rx.Receive_Byte_Counter = 0;		// Paket Byte Counter wieder auf 0 setzen
			Rx.Slave_Receive_Messege_Type = 0;	// MSG Type wieder auf 0
			return;
				
		}else{
			Rx.Receive_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
		}
	}
	
	if (Rx.Slave_Receive_Messege_Type == 0){
		Rx.Receive_Byte_Counter++;
	}

}
//***************************************************
//***************************************************


//***************************************************
//Funktion fr das Empfangen des Acknowledge Byte Slave
//***************************************************
void slave_receive_acknowledge (void){
	
	if(Rx.Receive_Byte_Counter == 0){
		Rx.i_Checksumme =0;
		Rx.HI_Checksumme=RF12_receive_WRT_CMD(0xB000);				// Checksumme auslesen
		Rx.Receive_Byte_Counter++;
		return;
	}

	if(Rx.Receive_Byte_Counter == 1){

		Rx.LOW_Checksumme=RF12_receive_WRT_CMD(0xB000);				// Checksumme auslesen
		
		RF12_receive_WRT_CMD(0x82D9); 								// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1	
		RF12_receive_WRT_CMD(0xCA81); 								// set FIFO mode	
		RF12_receive_WRT_CMD(0xCA83); 								// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
		Statusregister = RF12_receive_WRT_CMD(0x0000);

		Rx.Receive_Byte_Counter = 0;								// Paket Byte Counter wieder auf 0 setzen
		Tx.Transmit_Byte_Counter = 0;								// Paket Byte Counter wieder auf 0 setzen

		Rx.i_Checksumme = Rx.HI_Checksumme<<8 | Rx.LOW_Checksumme;	// Checksumme zusammenfhren	
		
		// CHECKSUMMENVERGLEICH BZW. ACKNOWLEDGEVERGLEICH
		// WENN CHECKSUMME RICHTIG EMPFANGEN
		if(Rx.i_Checksumme == Tx.i_Checksumme_Calc){
			Set_Modus_SlaveReceiveData();							// Modus setzen
			Tx.Resend_Flag = 0;										// Resen Flag auf 0 zurck setzen
			Ringpuffer_UART_to_RFM.WriteReadDifference--;			// Differenz lesen Schreiben verringern
			Tx.Correct_Transmit_Counter++;							// Counter fr korrekte bertragung erhhen	
			//uart_init;
		}
		//NIX TUN, FALSCHES ACKNOWLEDGE ERHALTEN
		//DATEN BEIM NCHSTEN ZYKLUS ERNEUT SENDEN
		else{
			Set_Modus_SlaveReceiveData();
			// --> Tx.Resend_Flag = 1 --> erneutes Senden im nchsten Zylus
		}

		Rx.Receive_Wait_Ack_Counter = 0;
		return;
	}
	else{
		Rx.Receive_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
	}
}
//***************************************************
//***************************************************
