#include "header.h"
#include "uart.h"



//***************************************************
//Funktion fr das Senden von einem Paket
//***************************************************

// WIRD AUS TIMER ISR AUFGERUFEN
void Master_Send_a_Packet(unsigned short ID_Receiver){


	// RESEND NOTWENDIG? (WENN ACKNOWLEDGE NICHT ERHALTEN)
	if(Tx.Resend_Flag == 1){	
		// MODUS SENDEN OHNE NEUES PAKET ZU HOLEN			
		Tx.Incorrect_Transmit_Counter++;				// Counter fr NICHT korrekte bertragung erhhen
		Set_Modus_MasterTransmitData();					// Modus Senden
		Tx.i_Checksumme_Calc = 0;						// Checksumme zurcksetzen
		Identifier.ID_Receiver_High = ID_Receiver>>8;	// Receiver ID Global schreiben, damit sie von ISR verwendet werden kann	
		Identifier.ID_Receiver_Low = ID_Receiver;		
		
		PIN_RFM_INIT();									// RFM12 Pins initialisieren
		RF12_receive_WRT_CMD(0x0000);					// Status lesen						
		RF12_transmit_WRT_CMD(0x8239);					// !er,!ebb,ET,ES,EX,!eb,!ew,DC
		// IRQ wird auf LOW gezogen --> Sprung in ISR(INT0_vect)
		Tx.All_Transmit_Paket_Counter++;				// Anzahl der Pakete die gesendet wurden erhhen
		return;
	}


// SENDEN WENN DATEN IM PUFFER
	if (Ringpuffer_UART_to_RFM.WriteReadDifference>0){
		
		//WENN MODUS RECEIVE (NORMAL)
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Resend_Flag == 0) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0)){
			Set_Modus_MasterTransmitData();					// Modus Senden		
			Tx.i_Checksumme_Calc = 0;						// Checksumme zurcksetzen
			GetAPacket();									// Aktuelles Paket vom Ringpuffer auf Array "PacketToSend" schreiben
			Identifier.ID_Receiver_High = ID_Receiver>>8;	// Receiver ID Global schreiben, damit sie von ISR verwendet werden kann	
			Identifier.ID_Receiver_Low = ID_Receiver;		
			
			PIN_RFM_INIT();									// RFM12 Pins initialisieren
			RF12_receive_WRT_CMD(0x0000);					// Status lesen								
			RF12_transmit_WRT_CMD(0x8239);					// !er,!ebb,ET,ES,EX,!eb,!ew,DC
			// IRQ wird auf LOW gezogen --> Sprung in ISR(INT0_vect)
			Tx.All_Transmit_Paket_Counter++;				// Anzahl der Pakete die gesendet wurden erhhen
			return;
		} 		
	}
}
//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Senden von einem Paket
//***************************************************
void Send_a_Request(unsigned short ID_Receiver){

	Set_Modus_MasterTransmitRequest();				// Modus Request Senden

	Identifier.ID_Receiver_High = ID_Receiver>>8;	// Receiver ID Global schreiben, damit sie von ISR verwendet werden kann	
	Identifier.ID_Receiver_Low = ID_Receiver;			
	
	PIN_RFM_INIT();									// RFM12 Pins initialisieren
	RF12_receive_WRT_CMD(0x0000);					// Status lesen								
	RF12_transmit_WRT_CMD(0x8239);					// !er,!ebb,ET,ES,EX,!eb,!ew,DC
	// IRQ wird auf LOW gezogen --> Sprung in ISR(INT0_vect)
	Tx.All_Request_Paket_Counter++;					// Anzahl der RequestPakete die gesendet wurden erhhen
}

//***************************************************
//***************************************************

//***************************************************
//Funktion fr die bermittlung des Acknowledge
//***************************************************
void Master_Send_Acknowledge(void)	
{		
	Set_Modus_MasterTransmitAck();					// Modus zum Senden des Acknowledge	
	
	Tx.i_Checksumme_Calc = 0;						// Checksumme zurcksetzen
	Tx.Transmit_Byte_Counter = 0;

	PIN_RFM_INIT();									// RFM12 Pins initialisieren
	Statusregister = RF12_receive_WRT_CMD(0x0000);	// Status lesen	
	
	//itoa(Statusregister,text,10);
	//uart_puts("\r\n Statusregister:");
	//uart_puts(text);							
	
	RF12_transmit_WRT_CMD(0x8239);					// !er,!ebb,ET,ES,EX,!eb,!ew,DC
	// IRQ wird auf LOW gezogen --> Sprung in ISR(INT0_vect)

} 
//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Senden von einem Request
//***************************************************
void master_transmit_request(void){

	testctr++;

	if(Tx.Transmit_Byte_Counter < 3){
		RF12_transmit_WRT_CMD(0xB800+0xAA);										// 3PREAMBLE senden;																			
	}
	
	if(Tx.Transmit_Byte_Counter == 3){
		RF12_transmit_WRT_CMD(0xB800+0x2D);										// SYNC HI BYTE											
	}
	
	if(Tx.Transmit_Byte_Counter == 4){
		RF12_transmit_WRT_CMD(0xB800+0xD4);										// SYNC LOW BYTE
	}

	if(Tx.Transmit_Byte_Counter == 5){
		RF12_transmit_WRT_CMD(0xB800+Identifier.ID_Receiver_High);				// High Byte ID schicken			
	}
	
	if(Tx.Transmit_Byte_Counter == 6){
		RF12_transmit_WRT_CMD(0xB800+Identifier.ID_Receiver_Low);				// Low Byte ID schicken			
	}

	if(Tx.Transmit_Byte_Counter == 7){
		RF12_transmit_WRT_CMD(0xB800+0x9A);										// SENDE MSG TYPE
	}

	if(Tx.Transmit_Byte_Counter == 8){
		RF12_transmit_WRT_CMD(0xB800+Identifier.ID_Receiver_High);				// High Byte ID schicken			
	}
	
	if(Tx.Transmit_Byte_Counter == 9){
		RF12_transmit_WRT_CMD(0xB800+Identifier.ID_Receiver_Low);				// Low Byte ID schicken
	}

	if(Tx.Transmit_Byte_Counter > 9){
		RF12_transmit_WRT_CMD(0xB800+0xAA);										//3 PREAMBLE senden	
	}
		
	if(Tx.Transmit_Byte_Counter == 11){			

		RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
		RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
		RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
	
		Statusregister = RF12_receive_WRT_CMD(0x0000);		
		Set_Modus_MasterReceiveRequest();		// Modus setzen		
		Tx.Transmit_Byte_Counter = 0;			// Paket Byte Counter wieder auf 0 setzen

		return;
	}
	else{
		Tx.Transmit_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
	}
}
//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Senden der Daten Bytes 
//***************************************************
void master_transmit_bytes(void){
		
	if(Tx.Transmit_Byte_Counter < 3){
		RF12_transmit_WRT_CMD(0xB800+0xAA);										// 3PREAMBLE senden;																			
	}
	
	if(Tx.Transmit_Byte_Counter == 3){
		RF12_transmit_WRT_CMD(0xB800+0x2D);										// SYNC HI BYTE											
	}
	
	if(Tx.Transmit_Byte_Counter == 4){
		RF12_transmit_WRT_CMD(0xB800+0xD4);										// SYNC LOW BYTE			
	}
	
	if(Tx.Transmit_Byte_Counter == 5){
		RF12_transmit_WRT_CMD(0xB800+Identifier.ID_Receiver_High);				// High Byte ID schicken			
	}
	
	if(Tx.Transmit_Byte_Counter == 6){
		RF12_transmit_WRT_CMD(0xB800+Identifier.ID_Receiver_Low);				// Low Byte ID schicken			
	}
	
	if(Tx.Transmit_Byte_Counter == 7){
		RF12_transmit_WRT_CMD(0xB800+0xAA);										// SENDE MSG TYPE
	}

	if((Tx.Transmit_Byte_Counter > 7) & (Tx.Transmit_Byte_Counter < 24)){		// DatenBytes senden
		RF12_transmit_WRT_CMD(0xB800+PacketToSend[Tx.Transmit_Byte_Counter-8]);
		Tx.i_Checksumme_Calc += PacketToSend [Tx.Transmit_Byte_Counter-8];		// Berechnung der Checksumme 
	}	

	if(Tx.Transmit_Byte_Counter == 24){
		Tx.HI_Checksumme_Calc = Tx.i_Checksumme_Calc>>8;
		Tx.LOW_Checksumme_Calc = Tx.i_Checksumme_Calc;

		RF12_transmit_WRT_CMD(0xB800+Tx.HI_Checksumme_Calc);					// Checksumme senden
		Tx.Checksumme_Send = Tx.i_Checksumme_Calc;								// Checksumme speichern
	}

	if(Tx.Transmit_Byte_Counter == 25){
		RF12_transmit_WRT_CMD(0xB800+Tx.LOW_Checksumme_Calc);					// Checksumme senden
		Tx.Checksumme_Send = Tx.i_Checksumme_Calc;								// Checksumme speichern
	}
	
	if(Tx.Transmit_Byte_Counter > 25){
		RF12_transmit_WRT_CMD(0xB800+0xAA);										//3 PREAMBLE senden
	}
	
	if(Tx.Transmit_Byte_Counter == 27){	
	
		RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
		RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
		RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
		
		Statusregister = RF12_receive_WRT_CMD(0x0000);
				
		Set_Modus_MasterReceiveAck();	// Set Modus: Empfange Acknowledge
		Tx.Transmit_Byte_Counter = 0;	// Paket Byte Counter wieder auf 0 setzen
		Rx.Receive_Byte_Counter  = 0;	// Paket Byte Counter wieder auf 0 setzen
		// WIRD RCKGESETZT WENN ACK RICHTIG ERHALTEN WURDE
		Tx.Resend_Flag = 1;

		//RF12_transmit_WRT_CMD(0xB800+0xAA);

		return;
	}
	else{
		Tx.Transmit_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
	}
}
//***************************************************
//***************************************************


void master_transmit_acknowledge (void){
	
	if(Tx.Transmit_Byte_Counter < 3){
		RF12_transmit_WRT_CMD(0xB800+0xAA);				// 3PREAMBLE senden;
	}
	
	if(Tx.Transmit_Byte_Counter == 3){
		RF12_transmit_WRT_CMD(0xB800+0x2D);				// SYNC HI BYTE											
	}
	
	if(Tx.Transmit_Byte_Counter == 4){
		RF12_transmit_WRT_CMD(0xB800+0xD4);				// SYNC LOW BYTE			
	}	

	if(Tx.Transmit_Byte_Counter == 5){					// AcknowledgeByte senden
		RF12_transmit_WRT_CMD(0xB800+Rx.HI_Checksumme);						
	}
	
	if(Tx.Transmit_Byte_Counter == 6){					// AcknowledgeByte senden
		RF12_transmit_WRT_CMD(0xB800+Rx.LOW_Checksumme);						
	}
	
	if(Tx.Transmit_Byte_Counter > 6){
		RF12_transmit_WRT_CMD(0xB800+0xAA);				//3 PREAMBLE senden
	}
	
	if(Tx.Transmit_Byte_Counter == 8){
		
		TOGGLE_LED1();

		RF12_receive_WRT_CMD(0x82D9); 					// RX on ... Power Management Command: er=1, ebb=1, et=0, es=0, ex=1, eb=0, ew=0, dc=1
		RF12_receive_WRT_CMD(0xCA81); 					// set FIFO mode
		RF12_receive_WRT_CMD(0xCA83); 					// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
		
		Statusregister = RF12_receive_WRT_CMD(0x0000);		
		
		Tx.Transmit_Byte_Counter = 0;					// Paket Byte Counter wieder auf 0 setzen
		Set_Modus_MasterReceiveData();					// Modus setzen
		return;
	}
	else{
		Tx.Transmit_Byte_Counter++;		// Paket Byte Counter um 1 erhhen
	}
}
