#include "header.h"
#include "uart.h"


//---------------------------------------------------
//Modus Set_Modus_MasterTransmitData setzen
//---------------------------------------------------
void Set_Modus_MasterTransmitData(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 1;						
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;	
	Tx.Request_Flag		= 0;	

	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_MasterTransmitRequest setzen
//---------------------------------------------------
void Set_Modus_MasterTransmitRequest(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 1;

	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus TransmitData setzen
//---------------------------------------------------
void Set_Modus_MasterTransmitAck(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 1;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 0;	
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_MasterReceiveAck setzen
//---------------------------------------------------
void Set_Modus_MasterReceiveAck(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 0;

	Rx.Acknowledge_Flag = 1;
	Rx.Request_Flag 	= 0;
	
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_MasterReceiveRequest setzen
//---------------------------------------------------
void Set_Modus_MasterReceiveRequest(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 0;

	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 1;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_MasterReceiveData setzen
//---------------------------------------------------
void Set_Modus_MasterReceiveData(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 0;
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_MasterResendData setzen
//---------------------------------------------------
void Set_Modus_MasterResendData(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 0;
	// WIRD ERST DANN WIEDER ZURCK GESETZT WENN ACK RICHTIG EMPFANGEN WURDE
	Tx.Resend_Flag 		= 1;
	Tx.Request_Flag		= 0;
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------












//---------------------------------------------------
//Modus Set_Modus_MasterReceiveData setzen
//---------------------------------------------------
void Set_Modus_SlaveReceiveData(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;						
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 0;
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus TransmitData setzen
//---------------------------------------------------
void Set_Modus_SlaveTransmitAck(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;					
	Tx.Acknowledge_Flag = 1;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 0;	
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_SlaveTransmitRequest setzen
//---------------------------------------------------
void Set_Modus_SlaveTransmitRequest(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 0;					
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 1;	
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_SlaveTransmitData setzen
//---------------------------------------------------
void Set_Modus_SlaveTransmitData(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	
	Tx.Flag 			= 1;					
	Tx.Acknowledge_Flag = 0;
//	Tx.Resend_Flag 		= 0;
	Tx.Request_Flag		= 1;	
	
	Rx.Acknowledge_Flag = 0;
	Rx.Request_Flag 	= 0;
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------

//---------------------------------------------------
//Modus Set_Modus_MasterReceiveAck setzen
//---------------------------------------------------
void Set_Modus_SlaveReceiveAck(void){
	
	cli(); 											// Globales Interrupts ausschalten solang der Modus gesetzt wird
	

	Tx.Flag 			= 0;						// Modus Empfange Acknowledge
	Tx.Acknowledge_Flag = 0;	
	// WIRD ERST DANN WIEDER ZURCK GESETZT WENN ACK RICHTIG EMPFANGEN WURDE
	Tx.Resend_Flag 		= 1;
	Tx.Request_Flag		= 0;

	Rx.Acknowledge_Flag = 1;
	Rx.Request_Flag 	= 0;
	
	
	sei();	
} 
//---------------------------------------------------
//---------------------------------------------------
