#include "header.h"
#include "uart.h"

volatile unsigned int i_z = 0; //laufvariable fr timer
volatile unsigned int i_y = 0; //laufvariable fr timer
volatile unsigned int RFM_receive_byte_counter_SAVE = 0;
volatile unsigned int RFM_transmit_byte_counter_SAVE = 0;



//***************************************************
//ISR UART Transmit
//***************************************************
SIGNAL(SIG_UART_TRANS)	
//ISR for transmitting via serial Interface
{
	while (!(UCSRA & (1<<UDRE)));  	//warten bis Senden moeglich 

}
//***************************************************
//***************************************************

//***************************************************
//ISR UART Receive
//***************************************************
SIGNAL(SIG_UART_RECV)
//ISR for receiving a sign via serial Interface
{

	uint8_t data;
	data = UDR;
	
 	switch (data)
 	{
   		case '1':{	uart_puts("\r\nMENU: \r\n ------------------------------------------------------ \r\n a: LED2 Toggeln \r\n b: LED1 Toggeln \r\n c: Fehlerspeicher auslesen \r\n d: Fehlerspeicher loeschen \r\n e: Dummy Puffer schreiben \r\n f: Letztes Paket erneut senden \r\n g: aktuellen Modus abfragen \r\n");}
					break;
 		case 'a':{	TOGGLE_LED2(); 
   					uart_puts("\r\nLED2 wurde getoggelt" );}
					break;
					return;
   		case 'b':{	TOGGLE_LED1(); 
   					uart_puts ("\r\nLED1 wurde getoggelt" );}
					break;
		case 'c':{	uart_puts ("\r\nFehlerspeicher wird ausgelesen" );}
//					read_ErrorMemory();
					break;
		case 'd':{	//delete_ErrorMemory();
					uart_puts ("\r\nFehlerspeicher wurde geloescht" );}
					break;
		case 'e':{	
		
					load_dummy();
																
					uart_puts ("\r\nDummy Puffer beschrieben" );}
					break;
		case 'f':{	uart_puts ("\r\nPacket erneut senden" );
//					Resend_a_Packet();	
					}
					break;
		case 'g':{	
					CurrentState();			
					uart_puts("\r\n \r\n");
					}
					break;
		case 'i':{
					uart_puts("\r\n");
					for(uint8_t zeile = 0; zeile < 8; zeile++){ 
						for(uint8_t spalte = 0; spalte < 16; spalte++){ 
							
							uart_putc(Ringpuffer_RFM_to_UART.Value[zeile][spalte]);
							//itoa(Ringpuffer_RFM_to_UART.Value[zeile][spalte],text,10);
							//uart_puts("\r\nRFM_to_UART= ");
							//uart_puts(text);
				   		}
						uart_puts("\r\n");
					}
				}
					break;
		case 'h':{

/*					for(uint8_t zeile = 0; zeile < 16; zeile++){ 
						for(uint8_t spalte = 0; spalte < 16; spalte++){ 
						Ringpuffer1.Value[zeile][spalte] = 0;
						Ringpuffer2.Value[zeile][spalte] = 0;
						}
					}*/
					
					uart_puts("\r\n");
					for(uint8_t zeile = 0; zeile < 8; zeile++){ 
						for(uint8_t spalte = 0; spalte < 16; spalte++){ 
						

						uart_putc(Ringpuffer_UART_to_RFM.Value[zeile][spalte]);
					//	itoa(Ringpuffer_UART_to_RFM.Value[zeile][spalte],text,10);
					//	uart_puts("\r\nUART_to_RFM= ");
					//	uart_puts(text);
						}
						
						uart_puts("\r\n");
					}
					break;
					
				}
					
   		default : {//UDR = data;
				   WriteAByte(data,1);}

 }
}
//***************************************************
//***************************************************

//***************************************************
//ISR fr Timer0
//***************************************************
ISR(TIMER0_COMP_vect){
	
	i_z++;
	i_y++;
	
	// WENN MASTER BOARD
	if(Identifier.ID_My_Board == Identifier.ID_Board_1){
		
		// EINSTELLUNG: MASTER DATEN, REQUEST ABFOLGE!!!
		if((i_z==2) & (Tx.Transmit_Paket_Counter > 0)){
			if (bit_is_set(PIN_LED2,LED2) ){								// WENN LED2 AN! ('a' ber Terminal senden)
				if (Identifier.ID_My_Board == Identifier.ID_Board_1){		// Nachricht an das andere Board schicken
					Send_a_Request(Identifier.ID_Board_2);					// Funktion aufrufen zum senden eines Request Paketes
					Tx.Transmit_Paket_Counter = 0;											
				}	
			}
			i_z=0;
		}else if((i_z==2) & (Tx.Transmit_Paket_Counter < 1)) { 				//Funktion wird alle 20ms aufgerufen 	
			if (bit_is_set(PIN_LED2,LED2) ){	
				if (Identifier.ID_My_Board == Identifier.ID_Board_1){		// Nachricht an das andere Board schicken
					//uart_puts ("\r\n\r\n\r\nSEND");
				//	Resend_a_Packet(Identifier.ID_Board_2);					// Erst auf Resend Prfen
					Master_Send_a_Packet(Identifier.ID_Board_2);			// Funktion aufrufen zum senden eines Paketes
					Tx.Transmit_Paket_Counter++;							// Anzahl der Pakete die fr eine Periode erhhen											
				}
			}
			i_z=0;
		}
	}

	
	// FALLS NICHT ALLE BYTES EMPFANGEN WURDEN, FIFO CLEAREN
	if ((RFM_receive_byte_counter_SAVE == Rx.Receive_Byte_Counter) & (Rx.Receive_Byte_Counter != 0)){
		
		RF12_receive_WRT_CMD(0x0000);
		RF12_receive_WRT_CMD(0x82D9); // RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
		RF12_receive_WRT_CMD(0xCA81); // set FIFO mode
		RF12_receive_WRT_CMD(0xCA83); // enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
		RF12_receive_WRT_CMD(0x0000);
		RFM_receive_byte_counter_SAVE 	= 0;
		Rx.Receive_Byte_Counter			= 0;			

		if (Rx.Receive_Byte_Counter > 2){		
			char text[1];							// Ausgabe wie viele Bytes richtig empfangen wurden	
			itoa(Rx.Receive_Byte_Counter,text,10);			
			uart_puts ("\r\n Es wurden nur ");
			uart_puts (text);
			uart_puts (" von 19 Bytes empfangen. Es folgt ein RESET. \r\n");			
//			error_handler(IncompleteTransmission);	// in den Fehlerspeicher schreiben
		}
	}			
	RFM_receive_byte_counter_SAVE = Rx.Receive_Byte_Counter;		// Aktuelle Anzahl des empfangenen Bytes sichern, fr nchsten Interruptaufruf

	// FALLS NICHT ALLE BYTES GESENDET WURDEN, FIFO CLEAREN
	if ((RFM_transmit_byte_counter_SAVE == Tx.Transmit_Byte_Counter) & (Tx.Transmit_Byte_Counter != 0)){
		
		if ((Tx.Flag == 1) & (Tx.Acknowledge_Flag == 0) & (Rx.Acknowledge_Flag == 0)){
			RF12_receive_WRT_CMD(0x0000);
			RF12_receive_WRT_CMD(0x82D9); // RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
			RF12_receive_WRT_CMD(0xCA81); // set FIFO mode
			RF12_receive_WRT_CMD(0xCA83); // enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1
			RF12_receive_WRT_CMD(0x0000);
			Tx.Transmit_Byte_Counter= 0;				
			uart_puts ("\r\n TRANSERROR  ");
			Tx.Resend_Flag = 1;
		}
	}			
	RFM_transmit_byte_counter_SAVE = Tx.Transmit_Byte_Counter;		// Aktuelle Anzahl des gesendeten Bytes sichern, Fr nchsten Interruptaufruf

}
//***************************************************
//***************************************************	

//***************************************************
//ISR fr NIRQ
//***************************************************
ISR(INT0_vect){
					
	cli();																			// Globale Interrupts deaktivieren				
	RF12_receive_WRT_CMD(0x0000);													// Statusbits lesen;
	
	//WENN SLAVE
	if(Identifier.ID_My_Board == Identifier.ID_Board_2){								//Check ob BoardID == SlaveID
		
		//EMPFANGEN SLAVE
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0)){														
			slave_receive_bytes();														// Funktionsaufruf transmit_bytes
			sei();																		// Globale Interrupts aktivieren
			return;
		}
		
		//SENDEN ACKNOWLEDGE SLAVE
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 1) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0)){															
			slave_transmit_acknowledge();												// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}
		
		//BEANTWORTEN DER REQUEST ANFRAGE
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Resend_Flag == 0) & (Tx.Request_Flag == 1) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0)){		
			slave_transmit_request();													// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}

		//EMPFANGEN ACKNOWLEDGE SLAVE
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 1) & (Rx.Request_Flag == 0)){															
			slave_receive_acknowledge();												// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}
		
		//SENDEN SLAVE oder RESEND
		if (((Tx.Flag == 1) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 1) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0))
		   |(Tx.Resend_Flag == 1)){	
			slave_transmit_bytes();														// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}				
	}
		
	//WENN MASTER
	if(Identifier.ID_My_Board == Identifier.ID_Board_1){								//Check ob BoardID == MasterID
		
		
			
		//EMPFANGEN ACKNOWLEDGE MASTER
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 1) & (Rx.Request_Flag == 0)){															
			master_receive_acknowledge();												// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}


		//SENDEN ACKNOWLEDGE MASTER
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 1)  & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0)){															
			master_transmit_acknowledge();												// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}
		
		//SENDEN REQEUEST MASTER
		//UNABHNGIG VOM Rx.Acknowledge_Flag
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 1) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0)){		// Wenn Modus Request Senden													
			master_transmit_request();													// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}
	
		//EMPFANGEN REQEUEST MASTER
		//UNABHNGIG VOM Rx.Acknowledge_Flag
		if ((Tx.Flag == 0) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 1)){		// Wenn Modus Request Empfangen												
			//uart_puts("R");
			master_receive_request();													// Funktionsaufruf
			sei();																		// Globale Interrupts aktivieren
			return;
		}
		
		//SENDEN MASTER oder RESEND
		if (((Tx.Flag == 1) & (Tx.Acknowledge_Flag == 0) & (Tx.Request_Flag == 0) & (Rx.Acknowledge_Flag == 0) & (Rx.Request_Flag == 0))
		   |(Tx.Resend_Flag == 1)){	
			master_transmit_bytes();													// Funktionsaufruf transmit_bytes
			sei();																		// Globale Interrupts aktivieren
			return;
		}
	}

	sei();
	
}
//***************************************************
//***************************************************
