#include "header.h"
#include "uart.h"




//***************************************************
//INIT UART
//***************************************************
void uart_init(void)
{

//Initialization UART
UBRRH=(uint8_t)(UART_BAUD_CALC(UART_BAUD_RATE,F_CPU)>>8);
UBRRL=(uint8_t)UART_BAUD_CALC(UART_BAUD_RATE,F_CPU);

UCSRB |= (1<<RXEN) | (1<<TXEN); //enable RxD & TxD
UCSRB |= (1<<RXCIE) | (1<<TXCIE);
}


//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Senden eines Zeichens auf den UART
//***************************************************
uart_putc (const uint8_t c)
{
	sei();			// globale Interrupts aktivieren

    // Warten, bis UDR bereit ist fr einen neuen Wert 
    while (!(UCSRA & (1 << UDRE)));

    // UDR Schreiben startet die bertragung 
    UDR = c;

    return 1;
}


//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Senden eines Strings auf den UART
//***************************************************
void uart_puts (const char *s){

	sei();				// globale Interrupts aktivieren

	do	
	{
    	uart_putc (*s);
    }
    while (*s++);
}

//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Senden eines Pakets aus dem Ringpuffer auf dem UART
//***************************************************

void Write_to_UART(void){
	
	if(Ringpuffer_RFM_to_UART.WriteReadDifference>0){

		if(Ringpuffer_RFM_to_UART.PositionToRead >= 8){ 									// Ring schlieen
			Ringpuffer_RFM_to_UART.PositionToRead = 0;										// Ring schlieen
		}
		
		uart_puts("\r\n");
		for(uint8_t i = 0; i < 16; i++){  	
			uart_putc(Ringpuffer_RFM_to_UART.Value[Ringpuffer_RFM_to_UART.PositionToRead][i]);
	   	}
		Ringpuffer_RFM_to_UART.PositionToRead++;											// Ring erhhen
		Ringpuffer_RFM_to_UART.WriteReadDifference--;
	}
}

//***************************************************
//***************************************************

