#include "header.h"
#include "uart.h"




//***************************************************
// Main Initialisierung
//***************************************************
void Main_Init(void){

	uart_init();
	
	//HyperTerminal Text schreiben
	uart_puts ("\r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n \r\n");
	uart_puts ("Bitte die '1' druecken um das Menu aufzurufen! \r\n");
	

	PIN_RFM_INIT();
	RF12_receive_INIT();
	
	//DEBUGG VARS
	Statusregister = 0;
	testctr = 0;

	Statusregister = RF12_receive_WRT_CMD(0x0000);
	itoa(Statusregister,text,10);
	uart_puts("\r\n Statusregister:");
	uart_puts(text);
	

	// VAR INIT
	Rx.Receive_Byte_Counter 					= 0;					
	Rx.Flag 									= 0;					
	Rx.RequestFlag								= 0;
	Rx.Acknowledge_Flag 						= 0;
	Rx.All_Receive_Paket_Counter 				= 0;	
	Rx.Correct_Receive_Counter	 				= 0;
	Rx.Incorrect_Receive_Counter				= 0;
	Rx.Acknowledge_Timeout						= 0;
	Rx.Master_Receive_Messege_Type				= 0;
	Rx.Slave_Receive_Messege_Type				= 0;

	Tx.All_Transmit_Paket_Counter 				= 0;
	Tx.All_Request_Paket_Counter				= 0;
	Tx.Transmit_ReSend_Counter 					= 0;
	Tx.Transmit_Paket_Counter					= 0;
	Tx.Incorrect_Transmit_Counter				= 0;
	Tx.Correct_Transmit_Counter					= 0;
	Tx.Transmit_Byte_Counter 					= 0;
	Tx.Acknowledge_Flag 						= 0;
	Tx.Resend_Flag								= 0;
	Tx.Resend_Timer								= 0;

	Ringpuffer_UART_to_RFM.PositionToWriteRow 	= 0;
	Ringpuffer_UART_to_RFM.PositionToWriteCol 	= 0;
	Ringpuffer_UART_to_RFM.WriteReadDifference	= 0;
	Ringpuffer_UART_to_RFM.PositionToRead		= 0;

	Ringpuffer_RFM_to_UART.PositionToRead = 0;
	Ringpuffer_RFM_to_UART.PositionToWriteRow 	= 0;
	Ringpuffer_RFM_to_UART.PositionToWriteCol 	= 0;
	Ringpuffer_RFM_to_UART.WriteReadDifference	= 0;

	uart.ReceivePacketCtr 						= 0;
	uart.TransmitPacketCtr 						= 0;	

	for(uint8_t zeile = 0; zeile < 8; zeile++){ 
		for(uint8_t spalte = 0; spalte < 16; spalte++){ 
		Ringpuffer_UART_to_RFM.Value[zeile][spalte] = 0;
		Ringpuffer_RFM_to_UART.Value[zeile][spalte] = 0;
		}
	}

	Identifier.ID_Board_1 = 0x4edc;					// ID vom Board 1 20188 MASTER
	Identifier.ID_Board_2 = 0x4def;					// ID vom Board 2 19951 SLAVE
	
	// ID ZUWEISEN!!!
	Identifier.ID_My_Board = Identifier.ID_Board_1;	
	
	// WENN MASTER BOARD
	if(Identifier.ID_My_Board == Identifier.ID_Board_1){
		Set_Modus_MasterReceiveData();
	}

	// WENN SLAVE BOARD
	if(Identifier.ID_My_Board == Identifier.ID_Board_2){
		Set_Modus_SlaveReceiveData();
	}
	
	// ID AUSGABE
	itoa(Identifier.ID_My_Board,text,10);
	uart_puts("\r\nMein ID ist: ");
	uart_puts(text);
	
	power_indication();								// Signal fr erfolgreiche Initialisierung
	
	//INTERUPTS FREIGEBEN
	INT0_interrupt_init();							// INT0 intialsisieren
	TIMER0_interrupt_init();						// Timer 0 intialsisieren als CTC (Clear to Compare)


}
//***************************************************
//***************************************************

//***************************************************
//wartet in ms
//***************************************************
void delay_ms(uint16_t time_in_ms)
{
  for(uint16_t t=0; t<=time_in_ms; t++)
	_delay_ms(1); 
}
//***************************************************
//***************************************************

//***************************************************
//3 mal LED Blinken
//***************************************************
void power_indication(void){
	
	//LED'S BLINKEN SCHOEN ...
	uint8_t z;
	LED1_OUTPUT();
	LED2_OUTPUT();
	LOW_LED2();
	LOW_LED1();

	for(z=0;z<3;z++){
		delay_ms(200);
		HI_LED2();
		delay_ms(200);
		TOGGLE_LED1();
		LOW_LED2();
	}
	delay_ms(1000);
	LOW_LED2();
	LOW_LED1();

}
//***************************************************
//***************************************************

//***************************************************
//Timer0 initialisieren
//***************************************************
void TIMER0_interrupt_init(void) {
	TIMSK|=(1<<OCIE0);								// Timer/Counter0 Output Compare Match Interrupt Enable			
	TCCR0 = ((1<<WGM01) | (1<<CS02) | (1<<CS00)); 	//Clear Timer on Compare Match (CTC) mode & Prescaler 1024 --> 16 Mhz/1024 = 15625Hz [alternativ auch TCCR0=0x0C;]	
	TCNT0=0;										// Anfangszhlerstand = 0	
	
	OCR0=255; 										// Zhler zhlt bis 256	--> 15625Hz/256 = 61 Hz 	--> Interrupt 16.4 ms
	//OCR0=155; 									// Zhler zhlt bis 156 --> 15625Hz/156 = 100.16 Hz --> Interrupt 10   ms
	//OCR0=100; 									// Zhler zhlt bis 91	--> 15625Hz/91 	= 171.7 Hz 	--> Interrupt 5.8  ms
}
//***************************************************
//***************************************************

//***************************************************
//INT0 initialisieren
//***************************************************
void INT0_interrupt_init(void) {
	MCUCR|=(1<<ISC01)|(1<<ISC00);		// fallende Flanke am INT0 lst Interrupt aus
	MCUCR &=~(1<<ISC00); 				// fallende Flanke am INT0 lst Interrupt aus
	GICR|=(1<<INT0); 					// INT0 im General Interrupt Control Register aktivieren
}
//***************************************************
//***************************************************	


//***************************************************
//Funktion fr das Holen des aktuellen Arrays aus dem Ringpuffer zum Senden ber das RFM12 Moduls
//***************************************************
void GetAPacket(void){
	
	if(Ringpuffer_UART_to_RFM.PositionToRead >= 8){ 									// Ring schlieen
		Ringpuffer_UART_to_RFM.PositionToRead = 0;										// Ring schlieen
	}
	for(uint8_t i = 0; i < 16; i++){  	
		PacketToSend[i] = Ringpuffer_UART_to_RFM.Value[Ringpuffer_UART_to_RFM.PositionToRead][i];	// aktuelles Paket aus dem Ringpuffer holen
		Ringpuffer_UART_to_RFM.Value[Ringpuffer_UART_to_RFM.PositionToRead][i] = 0;					// letzten Wert "lschen"
   	}
	Ringpuffer_UART_to_RFM.PositionToRead++;											// Ring erhhen
	
}
//***************************************************
//***************************************************

//***************************************************
//Funktion zum Schreiben eines Bytes in den Ringpuffer
//***************************************************
void WriteAByte(char Byte, unsigned char PufferType){

	if (PufferType == 1){
		if(Ringpuffer_UART_to_RFM.PositionToWriteRow >= 8){ 								// Ring schlieen
			Ringpuffer_UART_to_RFM.PositionToWriteRow = 0;									// Ring schlieen
		}

		if(Ringpuffer_UART_to_RFM.WriteReadDifference>6){									// Puffer Overflow verhindern und Flag setzen
			Ringpuffer_UART_to_RFM.Value[Ringpuffer_UART_to_RFM.PositionToWriteRow][Ringpuffer_UART_to_RFM.PositionToWriteCol] = Byte;
			Ringpuffer_UART_to_RFM.PositionToWriteCol++;		
			// Flag setzen das Puffer voll ist!
		}else{																	// Byte an die richtig Stelle im Puffer schreiben
			Ringpuffer_UART_to_RFM.Value[Ringpuffer_UART_to_RFM.PositionToWriteRow][Ringpuffer_UART_to_RFM.PositionToWriteCol] = Byte;		
			Ringpuffer_UART_to_RFM.PositionToWriteCol++;
		}	

		if(Ringpuffer_UART_to_RFM.PositionToWriteCol >= 16){
			uart.ReceivePacketCtr++;														// PaketCtr vom UART empfangen erhhen
			Ringpuffer_UART_to_RFM.WriteReadDifference++;									// Differenz lesen Schreiben erhhen
			Ringpuffer_UART_to_RFM.PositionToWriteCol = 0;									// Matrix schlieen
			Ringpuffer_UART_to_RFM.PositionToWriteRow++;									// Matrix schlieen
		}


	} else if (PufferType == 2){
		
		if(Ringpuffer_RFM_to_UART.PositionToWriteRow >= 8){ 								// Ring schlieen
			Ringpuffer_RFM_to_UART.PositionToWriteRow = 0;									// Ring schlieen
		}

		if(Ringpuffer_RFM_to_UART.WriteReadDifference>6){									// Puffer Overflow verhindern und Flag setzen
			Ringpuffer_RFM_to_UART.Value[Ringpuffer_RFM_to_UART.PositionToWriteRow][Ringpuffer_RFM_to_UART.PositionToWriteCol] = Byte;
			Ringpuffer_RFM_to_UART.PositionToWriteCol++;		
			// Flag setzen das Puffer voll ist!
		}else{																	// Byte an die richtig Stelle im Puffer schreiben
			Ringpuffer_RFM_to_UART.Value[Ringpuffer_RFM_to_UART.PositionToWriteRow][Ringpuffer_RFM_to_UART.PositionToWriteCol] = Byte;		
			Ringpuffer_RFM_to_UART.PositionToWriteCol++;
		}	

		if(Ringpuffer_RFM_to_UART.PositionToWriteCol >= 16){
			uart.TransmitPacketCtr++;														// PaketCtr zum UART Senden erhhen
			Ringpuffer_RFM_to_UART.WriteReadDifference++;									// Differenz lesen Schreiben erhhen
			Ringpuffer_RFM_to_UART.PositionToWriteCol = 0;									// Matrix schlieen
			Ringpuffer_RFM_to_UART.PositionToWriteRow++;									// Matrix schlieen
		}
		
	}
}
//***************************************************
//***************************************************	

//***************************************************
//berprfen ob die ID empfangene ID die eigene ist
//***************************************************
void ID_Control(void){
	
	Identifier.ID_Transmitted = Identifier.ID_Transmited_High<<8 | Identifier.ID_Transmited_Low;	// ID Bytes zusammenfhren
	if (Identifier.ID_My_Board == Identifier.ID_Transmitted){										// Prfe ob empfangene ID, eigene ID ist
	}else{
		
		LOW_SEL();
		RF12_receive_WRT_CMD(0x82D9); 	// RX on ... Power Management Command: er=1, ebb=1, et=0, es=1, ex=1, eb=0, ew=0, dc=1
		RF12_receive_WRT_CMD(0xCA81); 	// set FIFO mode
		RF12_receive_WRT_CMD(0xCA83); 	// enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1		
		Rx.Receive_Byte_Counter = 0;	// Paket Byte Counter wieder auf 0 setzen
//		error_handler(UnkownID); 		// Eintrag in den Fehlerspeicher		
	}
}
//***************************************************
//***************************************************

//***************************************************
//Dummy Bytes in den Puffer schreiben
//***************************************************
void load_dummy(void){

	LOW_LED2();
	
	cli();	

	uint8_t i = 32;			// Schreiben der Testpakete
	for(uint8_t zeile = 0; zeile < 8; zeile++){ 
		for(uint8_t spalte = 0; spalte < 16; spalte++){ 			
			i++;		
			if (i>112){
				i = 33;
			}
			WriteAByte(i,1);
   		}
	uart_puts(" ");
	itoa(Ringpuffer_UART_to_RFM.WriteReadDifference,text,10);
	uart_puts(text);
   	}

	sei();		
		
}
//***************************************************
//***************************************************

//***************************************************
//UART sperren
//***************************************************
void Disable_UART(void){
UCSRB &=~ (1<<RXEN); //enable RxD & TxD
UCSRB &=~ (1<<TXEN);
UCSRB &=~ (1<<RXCIE);
UCSRB &=~ (1<<TXCIE);
}

void Enable_UART(void){
UCSRB |= (1<<RXEN) | (1<<TXEN); //enable RxD & TxD
UCSRB |= (1<<RXCIE) | (1<<TXCIE);
}
//***************************************************
//***************************************************

//***************************************************
//Aktuelle Variablen wiedergeben (zum Debuggen)
//***************************************************
void CurrentState(void){

	itoa(Tx.Flag,text,10);
	uart_puts("\r\n Tx.Flag: ");
	uart_puts(text);

	itoa(Tx.Acknowledge_Flag,text,10);
	uart_puts("\r\n Tx.Acknowledge_Flag: ");
	uart_puts(text);

	itoa(Tx.Resend_Flag,text,10);
	uart_puts("\r\n Tx.Resend_Flag: ");
	uart_puts(text);

	itoa(Tx.Resend_Timer,text,10);
	uart_puts("\r\n Tx.Resend_Timer: ");
	uart_puts(text);
	
	itoa(Tx.Request_Flag,text,10);
	uart_puts("\r\n Tx.Request_Flag: ");
	uart_puts(text);

	itoa(Rx.Flag,text,10);
	uart_puts("\r\n\r\n Rx.Flag: ");
	uart_puts(text);

	itoa(Rx.Acknowledge_Timeout,text,10);
	uart_puts("\r\n Rx.Acknowledge_Timeout: ");
	uart_puts(text);

	itoa(Rx.RequestFlag,text,10);
	uart_puts("\r\n Rx.RequestFlag: ");
	uart_puts(text);

	itoa(Rx.Acknowledge_Flag,text,10);
	uart_puts("\r\n Rx.Acknowledge_Flag: ");
	uart_puts(text);

	itoa(Rx.Receive_Byte_Counter,text,10);
	uart_puts("\r\n Rx.Receive_Byte_Counter: ");
	uart_puts(text);

	itoa(Tx.Transmit_Byte_Counter,text,10);
	uart_puts("\r\n\r\n Tx.Transmit_Byte_Counter: ");
	uart_puts(text);

	itoa(Tx.All_Request_Paket_Counter,text,10);
	uart_puts("\r\n Tx.All_Request_Paket_Counter: ");
	uart_puts(text);

	itoa(Ringpuffer_UART_to_RFM.WriteReadDifference,text,10);
	uart_puts("\r\nRingpuffer_UART_to_RFM.WriteReadDifference = ");
	uart_puts(text);
	uart_puts("\r\n");

	itoa(Ringpuffer_UART_to_RFM.PositionToRead,text,10);
	uart_puts("\r\nRingpuffer_UART_to_RFM.PositionToRead = ");
	uart_puts(text);
	uart_puts("\r\n");

	itoa(Rx.Correct_Receive_Counter,text,10);
	uart_puts("\r\n Rx.Correct_Receive_Counter: ");
	uart_puts(text);

	itoa(Rx.Incorrect_Receive_Counter,text,10);
	uart_puts("\r\n Rx.Incorrect_Receive_Counter: ");
	uart_puts(text);

	itoa(Tx.Correct_Transmit_Counter,text,10);
	uart_puts("\r\n Tx.Correct_Transmit_Counter: ");
	uart_puts(text);

	itoa(Tx.Incorrect_Transmit_Counter,text,10);
	uart_puts("\r\n Tx.Incorrect_Transmit_Counter: ");
	uart_puts(text);

	itoa(testctr,text,10);
	uart_puts("\r\n testctr: ");
	uart_puts(text);

	itoa(uart.TransmitPacketCtr,text,10);
	uart_puts("\r\n uart.TransmitPacketCtr: ");
	uart_puts(text);

	itoa(uart.ReceivePacketCtr,text,10);
	uart_puts("\r\n uart.ReceivePacketCtr: ");
	uart_puts(text);
	
	itoa(Statusregister,text,10);
	uart_puts("\r\n Statusregister:");

	uart_puts("\r\n");
	uart_puts("\r\n 0000");
	uart_puts(text);
	uart_puts("0000\r\n");
	uart_puts("\r\n");

}


