#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <string.h>
#include <stdlib.h>
#include "uart.h"


//#ifndef F_CPU
//#define F_CPU 16000000
//#endif

//#ifndef UART_BAUD_RATE
#define UART_BAUD_RATE 57600
//#define UART_BAUD_RATE 9600
//#endif
//#ifndef UART_BAUD_CALC(UART_BAUD_RATE,F_OSC)
#define UART_BAUD_CALC(UART_BAUD_RATE,F_OSC) ((F_CPU)/((UART_BAUD_RATE)*16L)-1)
//#endif


#define ToggleBit(ADDRESS,BIT) ((ADDRESS) ^= (1<<BIT)

//allgemeine Funktionen deklarieren
//***********************************************************************
void delay_ms(uint16_t);
void power_indication(void);
uint8_t taster_abfrage(uint8_t active_nr);

//Routinen zum Empfangen und Senden*********************************** 
char receive_routine(void);
void transmit_routine(void);

//RFM12 Initialisirung auf Empfangen und Senden
void init_receive_rfm12(void); 
void init_transmit_rfm12(void);


//receive Functions
//void RF12_receive_PORT_INIT(void);
unsigned int RF12_receive_WRT_CMD(unsigned int aCmd);
void RF12_receive_INIT(void);
//unsigned char RF12_receive_RECV(void);

//transmit Functions
 //Aufruf der receive init
//void RF12_transmit_PORT_INIT(void);
unsigned int RF12_transmit_WRT_CMD(unsigned int aCmd);
void RF12_transmit_INIT(void);
//void RF12_transmit_SEND(unsigned char aByte);

void PIN_RFM_INIT(void);

void Main_Init(void);
void transmit_Acknowledge(void);
void INT0_interrupt_init(void);
void TIMER0_interrupt_init(void);
void TIMER0_interrupt_init(void);
void uart_puts(const char *s);
int  uart_putc (const uint8_t c);
void Read_a_Packet(void);


//ATMEGA32 PORTB*********************************************************
#define PORT_SEL PORTB
#define PIN_SEL PINB
#define DDR_SEL DDRB

#define PORT_SDI PORTB
#define PIN_SDI PINB
#define DDR_SDI DDRB

#define PORT_SCK PORTB
#define PIN_SCK PINB
#define DDR_SCK DDRB

#define PORT_SDO PORTB
#define PIN_SDO PINB
#define DDR_SDO DDRB

#define PORT_DATA PORTB
#define PIN_DATA PINB
#define DDR_DATA DDRB

#define PORT_Taster1 PORTB
#define PIN_Taster1 PINB
#define DDR_Taster1 DDRB

#define PORT_NINT_VDI PORTB
#define PIN_NINT_VDI  PINB
#define DDR_NINT_VDI  DDRB

//PortB Variablenfestlegung		Atmega32*******************************
#define RF12_SCK      7// 			|SCK	
#define RF12_SDO      6// 			|MISO	
#define RF12_SDI      5// 			|MOSI	
#define RF12_SEL      4// 			|SS	
#define RF12_DATA     3// 			|AIN1
//#define		      2// 			|AIN0	
#define Taster1       1// 			|T1, Taster1 vom Funk EVA	
//#define RF12_NINT_VDI 0// 		|T0


//PIN_PORT Funktionen**************************************************
//7
#define SCK_OUTPUT() 			DDR_SCK |= (1<<RF12_SCK)
#define HI_SCK() 				PORT_SCK|= (1<<RF12_SCK)
#define LOW_SCK() 				PORT_SCK&=~(1<<RF12_SCK)
//6
#define SDO_INPUT() 			DDR_SDO &= ~(1<<RF12_SDO) //deklaration auf input
//#define LOW_SDO() 			PORT_SDO  &= (1<<RFXX_SDO)
#define SDO_HI() 				PIN_SDO    &(1<<RF12_SDO)
#define WAIT_SDO_HI()			while (!(PIN_SDO & (1<<RF12_SDO))) //warte solange SDO null ist
//5
#define SDI_OUTPUT() 			DDR_SDI |= (1<<RF12_SDI)
#define HI_SDI() 				PORT_SDI|= (1<<RF12_SDI)
#define LOW_SDI() 				PORT_SDI&=~(1<<RF12_SDI)
//4
#define SEL_OUTPUT() 			DDR_SEL |= (1<<RF12_SEL)
#define HI_SEL() 				PORT_SEL|= (1<<RF12_SEL)//auf 1 setzten
#define LOW_SEL() 				PORT_SEL&=~(1<<RF12_SEL)//auf 0 setzten
//3
#define DATA_OUTPUT() 			DDR_DATA|=1<<RF12_DATA//deklariere PB3 als ausgang
#define HI_DATA() 				PORT_DATA|=1<<RF12_DATA//PB3 auf 1
#define LOW_DATA()				PORT_DATA &=~(1<<RF12_DATA)
//1
#define Taster1_INPUT() 		DDR_Taster1 &= ~(1<<Taster1) //deklaration auf input
//0
//#define NINT_VDI_OUTPUT() 	DDR_NINT_VDI |= (1<<RF12_SCK)
//#define HI_NINT_VDI() 		PORT_NINT_VDI|= (1<<RF12_SCK)
//#define LOW_NINT_VDI() 		PORT_NINT_VDI&=~(1<<RF12_SCK)


//ATMEGA32 PORTD*********************************************************

#define PORT_IRQ PORTD
#define PIN_IRQ PIND
#define DDR_IRQ DDRD

#define PORT_LED2 PORTD
#define PIN_LED2 PIND
#define DDR_LED2 DDRD

#define PORT_LED1 PORTD
#define PIN_LED1 PIND
#define DDR_LED1 DDRD

//PortD Variablenfestlegung		Atmega32*******************************
//#define   				7// 			|OC2	
#define LED1     			6// 			|ICP	
#define LED2				5// 			|OC1A	
//#define  					4// 			|OC1B	
#define RF12_DCLK_CFIL_FFIT 3// 			|INT1
#define RF12_IRQ  			2// 			|INT0	
//#define     				1// 			|TXD	
//#define  					0// 			|RXD

//PIN_PORT Funktionen**************************************************
//6
#define LED1_OUTPUT() 				DDRD|=(1<<LED1)//PD6 output
#define LOW_LED1() 					PORTD&=~(1<<LED1)
#define HI_LED1() 					PORTD|= (1<<LED1)
#define TOGGLE_LED1() 				PORTD ^= (1<<LED1)
//5
#define LED2_OUTPUT() 				DDRD|=(1<<LED2)
#define LOW_LED2() 					PORTD&=~(1<<LED2)
#define HI_LED2() 					PORTD|= (1<<LED2)
#define TOGGLE_LED2() 				PORTD ^= (1<<LED2)
//3
//#define RF12_DCLK_CFIL_FFIT_OUTPUT	DDRD|=(1<<RF12_DCLK_CFIL_FFIT)
//2
#define IRQ_INPUT()					DDR_IRQ  &=~(1<<RF12_IRQ)//PD2 als Eingang
#define IRQ_OUTPUT()				DDR_IRQ  |= (1<<RF12_IRQ)//PD2 als Ausgang
#define HI_IRQ() 					PORT_IRQ |=1<<RF12_IRQ   //PD2 auf 1 setzen
#define LOW_IRQ()					PORT_IRQ &=~(1<<RF12_IRQ)//PD2 auf 0 setzen
#define WAIT_IRQ_LOW() 				while(PIND&(1<<RF12_IRQ))//warte solange IRQ null ist
#define WAIT_IRQ_HI()				while!(PIND&(1<<RF12_IRQ)) // warte solange IRQ HIGH is


volatile unsigned int Statusregister;

//volatile unsigned char RFM_receive_byte_counter;
volatile unsigned int i_sekunde;

struct RxType {
	unsigned int  Status_Register;				// Speicher fr den WERT des StatusRegisters des RFM12 Moduls
	unsigned char Receive_Byte_Counter;			// zhlt Datenbytes pro Paket
	unsigned char FiFo_Puffer [16];				// 16 Daten Bytes
	unsigned char Flag;							// wird 1 wenn Daten im Puffer bereitstehen
	unsigned char RequestFlag;

	unsigned int  i_Checksumme;					// Checksumme erhalten HI & LOW 
	unsigned char LOW_Checksumme;				// Checksumme erhalten LOW
	unsigned char HI_Checksumme;				// Checksumme erhalten HI
	unsigned int  i_Checksumme_Calc;			// Checksumme berechnet aus Datenbytes
	
	unsigned char Acknowledge_Flag;				// Empfange Acknowledge
	unsigned char Request_Flag;					// Empfange Request

	unsigned int  All_Receive_Paket_Counter;	// zhlt die Empfangenen Pakete
	unsigned char Receive_Wait_Ack_Counter;

	unsigned int  Correct_Receive_Counter;	// Zhlt Daten die korrekt bertragen wurden	
	unsigned int  Incorrect_Receive_Counter;// Zhlt Daten die inkorrekt bertragen wurden	

	unsigned int  Acknowledge_Timeout;			// Zhlt Daten die inkorrekt bertragen wurden

	unsigned char Master_Receive_Messege_Type;	//
	unsigned char Slave_Receive_Messege_Type;	//
	
	};

struct TxType {
	unsigned int  Status_Register;				// Speicher fr den WERT des StatusRegisters des RFM12 Moduls
	unsigned char Transmit_Byte_Counter;		// zhlt Datenbytes pro Paket
	unsigned char FiFo_Puffer [16];				// 16 Daten Bytes
	unsigned char Flag;							// wird 1 wenn Daten im Puffer bereitstehen
	
	unsigned int  i_Checksumme;					// Checksumme erhalten HI & LOW 
	unsigned char LOW_Checksumme_Calc;			// Checksumme erhalten LOW
	unsigned char HI_Checksumme_Calc;			// Checksumme erhalten HI
	unsigned int  i_Checksumme_Calc;			// Checksumme berechnet aus Datenbytes

	unsigned int  Correct_Transmit_Counter;	// Zhlt Daten die korrekt bertragen wurden
	unsigned int  Incorrect_Transmit_Counter;// Zhlt Daten die inkorrekt bertragen wurden



	unsigned char Acknowledge_Flag;				// Sende Acknowledge
	unsigned char Request_Flag;					// Sende Request
	unsigned int  All_Transmit_Paket_Counter;	// zhlt alle bertragenen Pakete
	unsigned int  All_Request_Paket_Counter;
	unsigned char Transmit_Paket_Counter;		// zhlt die bertragenen Pakete der Periode
	unsigned char Checksumme_Send;				// letzte Checksumme die gesendet wurde
	unsigned char Transmit_ReSend_Counter; 		// zhlt erneutes senden falls Acknowledgebyte falsch war
	unsigned char Resend_Flag;					// Startet Timer, bestimmte Zeit im Receive Modus bevor Resend gestartet wird
	unsigned char Resend_Timer;
	};

volatile struct RxType Rx ;
volatile struct TxType Tx ;

volatile unsigned char PacketToSend[16];		// Globale aktueller Wert der aus dem Ringpuffer genommen wird


struct IdentifierType{
	unsigned short ID_Board_1;					// ID vom Board 1
	unsigned short ID_Board_2 ;					// ID vom Board 2
	//...
	unsigned short ID_My_Board;					// Zuweisung der ID im MAIN_INIT
	unsigned short ID_Transmitted;

	unsigned char  ID_Receiver_High;			// Zuweisung der ID_High an das Board an welches eine Nachricht geschickt werden soll
	unsigned char  ID_Receiver_Low;				// Zuweisung der ID_Low an das Board an welches eine Nachricht geschickt werden soll
	
	unsigned char  ID_Transmited_High;			// Zuweisung der ID_High an das Board an welches eine Nachricht geschickt werden soll
	unsigned char  ID_Transmited_Low;			// Zuweisung der ID_Low an das Board an welches eine Nachricht geschickt werden soll
	};
//volatile 
struct IdentifierType Identifier;

//typedef enum {AckknowledgeTimeout, IncompleteTransmission, ChecksummeError, UnkownID} ERRORCODE;	// Error code to analyze errors
//extern unsigned char error_handler(ERRORCODE errormsg);


struct RingpufferType{							// Ringpuffer
	unsigned char Value[8][16];					// Matrix mit 16 mal 16 Felder mit "Value[zeile][spalte]";
	unsigned char PositionToWriteCol;			// Position zum Schreiben in "spalte"
	unsigned char PositionToWriteRow;			// Position zum Schreiben in "zeile"
	unsigned char PositionToRead;				// Position zum Lesen in "zeile"
	unsigned char WriteReadDifference;
	};

volatile struct RingpufferType Ringpuffer_UART_to_RFM;		// UART zu RFM
volatile struct RingpufferType Ringpuffer_RFM_to_UART;		// RFM zu UART

//volatile unsigned long statuscontrol[50];
//volatile unsigned char i_statuscontrol;


char text[10];

struct uartType{
	unsigned int  ReceivePacketCtr;				// Zhlt die Pakete die vom UART EMpfangen wurden
	unsigned int  TransmitPacketCtr;
};
volatile struct uartType uart;

// Funktionen Deklaration
void CurrentState(void);
void Set_Modus_MasterTransmitData(void);
void Set_Modus_MasterTransmitRequest(void);
void Set_Modus_MasterReceiveAck(void);
void Set_Modus_MasterReceiveRequest(void);
void Set_Modus_MasterReceiveData(void);
void Set_Modus_MasterResendData(void);
void Set_Modus_MasterTransmitAck(void);
void Set_Modus_SlaveReceiveData(void);
void Set_Modus_SlaveTransmitAck(void);
void Set_Modus_SlaveTransmitRequest(void);
void Set_Modus_SlaveReceiveAck(void);
void Set_Modus_SlaveTransmitData(void);



void Send_a_Request(unsigned short);
void Master_Send_a_Packet(unsigned short);
void Master_Send_Acknowledge(void);
void Slave_Send_a_Packet(unsigned short);
void Send_Acknowledge(void);
void GetAPacket(void);
void WriteAByte(char, unsigned char);
void master_receive_request(void);
void master_transmit_request(void);
void read_ErrorMemory(void);
void load_dummy(void);
void delete_ErrorMemory(void);
void ID_Control(void);
void Write_to_UART(void);
void Read_a_Packet_RFM(void);

void slave_receive_bytes(void);
void slave_transmit_acknowledge(void);
void slave_transmit_bytes(void);
void slave_transmit_request(void);
void slave_receive_acknowledge(void);
void master_transmit_bytes(void);
void master_receive_acknowledge(void);
void master_transmit_acknowledge(void);




unsigned int testctr;
unsigned long teststatus;
