#include "header.h"
#include "uart.h"



//***************************************************
//Funktion fr das Lesen der SPI
//***************************************************
unsigned int RF12_receive_WRT_CMD(unsigned int aCmd){
 	unsigned char i;
  	unsigned int temp;
  	
	temp=0;
  	LOW_SCK();
  	LOW_SEL();
  	
	for(i=0;i<16;i++){
    	if(aCmd&0x8000){
      		HI_SDI();
      	}else{
      		LOW_SDI();
    	}
    
		HI_SCK();
    	temp<<=1;
    
		if(SDO_HI()){
     		temp|=0x0001;
    	}
    
		LOW_SCK();
    	aCmd<<=1;
  	};
  	
	HI_SEL();
 	return(temp);
}

//***************************************************
//***************************************************

//***************************************************
//Funktion fr das Schreiben der SPI
//***************************************************

unsigned int RF12_transmit_WRT_CMD(unsigned int aCmd){
  	unsigned char i;
  	unsigned int temp;
  	LOW_SCK();
  	LOW_SEL();
  	
	for(i=0;i<16;i++){
    	temp<<=1;
    	if(SDO_HI()){
      		temp|=0x0001;
    	}
    	
		LOW_SCK();
    	
		if(aCmd&0x8000){
      		HI_SDI();
      	}else{
      		LOW_SDI();
    	}
    	HI_SCK();
    	aCmd<<=1;
  	};
  	
	LOW_SCK();
  	HI_SEL();
  	return(temp);
}


//***************************************************
//***************************************************

//***************************************************
//INIT des RFM12 receive
//***************************************************

//  RF12_receive_WRT_CMD(0x80D7);//EL,EF,11.5pF
//  RF12_receive_WRT_CMD(0x82D9);//!er,!ebb,ET,ES,EX,!eb,!ew,DC
//  RF12_receive_WRT_CMD(0xA640);//434MHz
//  RF12_receive_WRT_CMD(0xC605); //(0xC614);//19.2kbps      // 0xC647 = 4.8kbps

void RF12_receive_INIT(void){
  RF12_receive_WRT_CMD(0x80D7);//EL,EF,11.5pF
  RF12_receive_WRT_CMD(0x82D9);//!er,!ebb,ET,ES,EX,!eb,!ew,DC
  RF12_receive_WRT_CMD(0xA640);//434MHz
  RF12_receive_WRT_CMD(0xC614); //(0xC614);//19.2kbps      // 0xC647 = 4.8kbps 
  RF12_receive_WRT_CMD(0x94A0);//VDI,FAST,134kHz,0dBm,-103dBm
  RF12_receive_WRT_CMD(0xC2AC);//AL,!ml,DIG,DQD4
  RF12_receive_WRT_CMD(0xCA81);//FIFO8,SYNC,!ff,DR
  RF12_receive_WRT_CMD(0xC483);//@PWR,NO RSTRIC,!st,!fi,OE,EN
  RF12_receive_WRT_CMD(0x9850);//!mp,9810=30kHz,MAX OUT
  RF12_receive_WRT_CMD(0xE000);//NOT USE
  RF12_receive_WRT_CMD(0xC800);//NOT USE
  RF12_receive_WRT_CMD(0xC400);//1.66MHz,2.2V
  RF12_receive_WRT_CMD(0xCA83); // enable FIFO ... FIFO and Reset Mode Command: FIFO Level=8, al=0, ff=1, dr=1

}

//***************************************************
//***************************************************

//***************************************************
//INIT des RFM12 transmit
//***************************************************
/*
void RF12_transmit_INIT(void){
  RF12_transmit_WRT_CMD(0x80D7);//EL,EF,11.5pF
  //RF12_transmit_WRT_CMD(0x8239);//!er,!ebb,ET,ES,EX,!eb,!ew,DC
  RF12_transmit_WRT_CMD(0xA640);//A140=430.8MHz
  RF12_transmit_WRT_CMD(0xC614); //(0xC614);//19.2kbps      // 0xC647 = 4.8kbps
  RF12_transmit_WRT_CMD(0x94A0);//VDI,FAST,134kHz,0dBm,-103dBm
  RF12_transmit_WRT_CMD(0xC2AC);//AL,!ml,DIG,DQD4
  RF12_transmit_WRT_CMD(0xCA81);//FIFO8,SYNC,!ff,DR
  RF12_transmit_WRT_CMD(0xC483);//@PWR,NO RSTRIC,!st,!fi,OE,EN
  RF12_transmit_WRT_CMD(0x9850);//!mp,9810=30kHz,MAX OUT
  RF12_transmit_WRT_CMD(0xE000);//NOT USE
  RF12_transmit_WRT_CMD(0xC800);//NOT USE
  RF12_transmit_WRT_CMD(0xC400);//1.66MHz,2.2V
}
*/
//***************************************************
//***************************************************

//***************************************************
// PIN RFM INIT
//***************************************************

void PIN_RFM_INIT(void)
{  

  IRQ_INPUT();				// PD2(INT0) IRQ auf Low setzten
  DATA_OUTPUT(); 			// DATA als Output schreiben
  HI_DATA();				// SET nFFS pin HI when using TX register
  HI_IRQ();					// PULL UP aktiveren

  HI_SEL();
  HI_SDI();
  LOW_SCK();

  SEL_OUTPUT();
  SDI_OUTPUT();
  SDO_INPUT();
  SCK_OUTPUT();

}
//***************************************************
//***************************************************

